Remove the ixfr-from-differences side-effect which causes an AXFR and extend

request-ixfr to the zone level.
This commit is contained in:
Scott Mann
2011-09-06 22:29:33 +00:00
parent 9252f15750
commit fad5116b3d
13 changed files with 142 additions and 40 deletions

View File

@@ -15,7 +15,9 @@
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
# $Id: clean.sh,v 1.6 2007/09/26 03:22:43 marka Exp $
# $Id: clean.sh,v 1.7 2011/09/06 22:29:32 smann Exp $
rm -f ns1/named.conf ns1/myftp.db
rm -f ns3/*.jnl ns3/mytest.db ns3/subtest.db
rm -f ns4/*.jnl ns4/*.db
rm -f */named.memstats

View File

@@ -15,9 +15,9 @@
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
# $Id: setup.sh,v 1.4 2007/06/19 23:47:03 tbox Exp $
# $Id: setup.sh,v 1.5 2011/09/06 22:29:32 smann Exp $
rm -f ns1/*.db ns1/*.jnl
rm -f ns1/*.db ns1/*.jnl ns3/*.jnl ns4/*.jnl
cat <<EOF >ns1/named.conf
options {
@@ -41,3 +41,7 @@ controls {
inet 10.53.0.1 port 9953 allow { any; } keys { rndc_key; };
};
EOF
# Setup initial db files for ns3
cp ns3/mytest0.db ns3/mytest.db
cp ns3/subtest0.db ns3/subtest.db

View File

@@ -15,7 +15,13 @@
# OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
# PERFORMANCE OF THIS SOFTWARE.
# $Id: tests.sh,v 1.7 2011/03/05 23:52:29 tbox Exp $
# $Id: tests.sh,v 1.8 2011/09/06 22:29:32 smann Exp $
# WARNING: The test labelled "testing request-ixfr option in view vs zone"
# is fragile because it depends upon counting instances of records
# in the log file - need a better approach <sdm> - until then,
# if you add any tests above that point, you will break the test.
SYSTEMTESTTOP=..
. $SYSTEMTESTTOP/conf.sh
@@ -132,5 +138,67 @@ $DIGCMD nil. TXT | grep 'fallback AXFR' >/dev/null || {
status=1
}
echo "I:testing ixfr-from-differences option"
# ns3 is master; ns4 is slave
$CHECKZONE test. ns3/mytest.db > /dev/null 2>&1
if [ $? -ne 0 ]
then
echo "I:named-checkzone returned failure on ns3/mytest.db"
fi
# modify the master
#echo "I: digging against master: "
#$DIG $DIGOPTS @10.53.0.3 -p 5300 a host1.test.
#echo "I: digging against slave: "
#$DIG $DIGOPTS @10.53.0.4 -p 5300 a host1.test.
cp ns3/mytest1.db ns3/mytest.db
$RNDC -s 10.53.0.3 -p 9953 -c ../common/rndc.conf reload
sleep 2
# slave should have gotten notify and updated
INCR=`grep "test/IN/primary" ns4/named.run|grep "got incremental"|wc -l`
if [ $INCR -ne 1 ]
then
echo "I:failed to get incremental response"
status=1
fi
echo "I:testing request-ixfr option in view vs zone"
# There's a view with 2 zones. In the view, "request-ixfr yes"
# but in the zone "sub.test", request-ixfr no"
# we want to make sure that a change to sub.test results in AXFR, while
# changes to test. result in IXFR
echo "I: this result should be AXFR"
cp ns3/subtest1.db ns3/subtest.db # change to sub.test zone, should be AXFR
$RNDC -s 10.53.0.3 -p 9953 -c ../common/rndc.conf reload
sleep 2
echo "I: this result should be AXFR"
NONINCR=`grep 'sub\.test/IN/primary' ns4/named.run|grep "got nonincremental" | wc -l`
if [ $NONINCR -ne 2 ]
then
echo "I:failed to get nonincremental response in 2nd AXFR test"
status=1
else
echo "I: success: AXFR it was"
fi
echo "I: this result should be IXFR"
cp ns3/mytest2.db ns3/mytest.db # change to test zone, should be IXFR
$RNDC -s 10.53.0.3 -p 9953 -c ../common/rndc.conf reload
sleep 2
INCR=`grep "test/IN/primary" ns4/named.run|grep "got incremental"|wc -l`
if [ $INCR -ne 2 ]
then
echo "I:failed to get incremental response in 2nd IXFR test"
status=1
else
echo "I: success: IXFR it was"
fi
echo "I:exit status: $status"
exit $status